/*$$$ 
<filter id="contrastBrightnessShader" label="Contrast/Brightness" category="adjustment" vartype="custom">
	<var varname="contrast" label="Contrast" type="number" min="-100" max="100" default="0" />
	<var varname="brightness" label="Brightness" type="number" min="-100" max="100" default="0" />
</filter>
$$$*/

precision highp float;

uniform sampler2D tt_uniform_maintexture;

uniform int tt_uniform_imagewidth;
uniform int tt_uniform_imageheight;
uniform float tt_uniform_pixelwidth;
uniform float tt_uniform_pixelheight;

uniform float contrast;
uniform float brightness;

varying vec2 mainTexCoord;

void main()
{
     vec4 col = texture2D(tt_uniform_maintexture, mainTexCoord.xy);
     vec4 dst;
	
	if(contrast < 0.0)
	{
		col.rgb = max((col.rgb-0.5)*(1.0+contrast) + 0.5,0.0);
	    /*
	    col.r = max((col.r-0.5)*(1.0+contrast) + 0.5,0.0);
	    col.g = max((col.g-0.5)*(1.0+contrast) + 0.5,0.0);
	    col.b = max((col.b-0.5)*(1.0+contrast) + 0.5,0.0);
		*/
	}
	else
	{
		col.rgb = min(col.rgb + (col.rgb-0.5)*contrast,1.0);
	    /*
	    col.r = min(col.r + (col.r-0.5)*contrast,1.0);
	    col.g = min(col.g + (col.g-0.5)*contrast,1.0);
	    col.b = min(col.b + (col.b-0.5)*contrast,1.0);
	    */
	}
	
	if(brightness < 0.0)
	{
	    dst.rgb = col.rgb * (1.0+brightness);
	}
	else
	{
	    dst.rgb = col.rgb + brightness;
	}
	
	gl_FragColor.rgb = min(dst.rgb,col.a);
	gl_FragColor.a = col.a;
}
