/*$$$ 
<filter id="glassShader" label="Glass" category="effects" samplingMode="linear" vartype="custom"
	source1="noise" noiseWidth="256" noiseHeight="256" noiseBaseX="32.0" noiseBaseY="32.0" noiseOctaves="4">
	<var varname="amount" label="Amount" type="number"  min="0" max="300" default="20" />
	<var varname="scale" label="Amount" type="number" numPrecision="2" min="0.25" max="4.0" default="1" />
</filter>
$$$*/

precision highp float;

uniform sampler2D tt_uniform_maintexture;
uniform sampler2D tt_uniform_texture1;

uniform int tt_uniform_imagewidth;
uniform int tt_uniform_imageheight;
uniform int tt_uniform_surfacewidth;
uniform int tt_uniform_surfaceheight;
uniform float tt_uniform_pixelwidth;
uniform float tt_uniform_pixelheight;

uniform float amount;
uniform float scale;

varying vec2 mainTexCoord;

void main()
{
	vec2 coord = mainTexCoord;
	vec2 curCoord;
	vec2 pert;
	vec4 curCol;
	vec4 noiseCol;
	float val = scale; 
	// Offset by the center value
	
	curCoord.x = float(tt_uniform_surfacewidth)*coord.x/scale-1.0;
	curCoord.y = float(tt_uniform_surfaceheight)*coord.y/scale;
	
	curCoord.x -= floor(curCoord.x/256.0) * 256.0;
	curCoord.y -= floor(curCoord.y/256.0) * 256.0;
	
	curCoord.x /= 256.0;
	curCoord.y /= 256.0;
	
	curCol = texture2D( tt_uniform_texture1, curCoord ); 
	
	curCoord.x = float(tt_uniform_surfacewidth)*coord.x/val +1.0;
	curCoord.x -= floor(curCoord.x/256.0) * 256.0;
	
	curCoord.x /= 256.0;
	
	noiseCol = texture2D( tt_uniform_texture1, curCoord ); 
	
	pert.x = 2.0*(noiseCol.r - curCol.r);
	
	curCoord.x = float(tt_uniform_surfacewidth)*coord.x/val;
	curCoord.y = float(tt_uniform_surfaceheight)*coord.y/val - 1.0;
	
	curCoord.x -= floor(curCoord.x/256.0) * 256.0;
	curCoord.y -= floor(curCoord.y/256.0) * 256.0;
	
	curCoord.x /= 256.0;
	curCoord.y /= 256.0;
	
	curCol = texture2D( tt_uniform_texture1, curCoord ); 
	
	curCoord.y = float(tt_uniform_surfaceheight)*coord.y/val + 1.0;
	curCoord.y -= floor(curCoord.y/256.0) * 256.0;
	
	curCoord.y /= 256.0;
	noiseCol = texture2D( tt_uniform_texture1, curCoord ); 
	
	pert.y = 2.0*(noiseCol.r - curCol.r);
	
	
	coord += pert*vec2(tt_uniform_pixelwidth,tt_uniform_pixelheight)*amount;
	
	gl_FragColor = texture2D( tt_uniform_maintexture, coord ); 
	
}
