/*$$$ 
<filter id="grainyNightShader" label="Old Sepia" category="effects" vartype="intensity" source1="dirtMap">
	<var varname="intensity" label="Intensity" type="number" numFactor="100" min="0" max="1" default="0.5" />
	<var varname="brightness" label="Brightness" type="number" numFactor="100" min="0" max="1" default="0.5" />
</filter>
$$$*/

precision highp float;

uniform sampler2D tt_uniform_maintexture;
uniform sampler2D tt_uniform_texture1;

uniform int tt_uniform_imagewidth;
uniform int tt_uniform_imageheight;
uniform int tt_uniform_surfacewidth;
uniform int tt_uniform_surfaceheight;
uniform float tt_uniform_pixelwidth;
uniform float tt_uniform_pixelheight;

uniform float intensity;
uniform float brightness;

varying vec2 mainTexCoord;

void main()
{
	int imgWidth = tt_uniform_imagewidth;
	int imgHeight = tt_uniform_imageheight;
	int surfWidth = tt_uniform_surfacewidth;
	int surfHeight = tt_uniform_surfaceheight;
	float pixWidth = tt_uniform_pixelwidth;
	float pixHeight = tt_uniform_pixelheight;

    vec4 dst;
	vec4 rgbaColor;
	vec4 dirtCol;
	vec4 dCol;
	
	vec2 curCoord;
	float gradY;
	
	curCoord.x = 2.0 * mainTexCoord.x * float(surfWidth);
	curCoord.y = 2.0 * mainTexCoord.y * float(surfHeight);
	
	gradY = mainTexCoord.y*float(surfHeight)/float(imgHeight);
	
	curCoord.x -= floor(curCoord.x/512.0) * 512.0;
	curCoord.y -= floor(curCoord.y/512.0) * 512.0;
	
	curCoord.x /= 512.0;
	curCoord.y /= 512.0;
	
    rgbaColor = texture2D(tt_uniform_maintexture, mainTexCoord.xy);
	dirtCol = texture2D( tt_uniform_texture1, curCoord );
	
	float lum = smoothstep(2.0-3.0*brightness,4.0-3.0*brightness,rgbaColor.r + rgbaColor.g + rgbaColor.b);
	
	lum = min(lum,rgbaColor.a);
	
	rgbaColor.rgb = vec3(lum,lum,lum);

	lum = min(lum+max(gradY-0.5,0.0)*0.3334,1.0);
	
	float lum2  = smoothstep(-0.8+dirtCol.r,0.2+dirtCol.r,lum);
	
	dCol = vec4(lum2,lum2,lum2,1.0);
	dst = mix(rgbaColor,dCol,intensity);
	
	gl_FragColor = dst;
}
