/*$$$ 
<filter id="thresholdShader" label="Threshold" category="effects" vartype="custom" >
	<var varname="color1" label="Color 1" type="coloralpha" default="ff000000" />
	<var varname="color2" label="Color 2" type="coloralpha" default="ffffffff" />
	<var varname="threshold" label="Threshold" type="number" numFactor="100" min="0" max="1" default="0.5" />
	<var varname="smoothness" label="Smoothness" type="number" numFactor="100" min="0" max="1" default="0" />
</filter>
$$$*/

precision highp float;

uniform sampler2D tt_uniform_maintexture;

uniform int tt_uniform_imagewidth;
uniform int tt_uniform_imageheight;
uniform int tt_uniform_surfacewidth;
uniform int tt_uniform_surfaceheight;
uniform float tt_uniform_pixelwidth;
uniform float tt_uniform_pixelheight;

uniform vec4 color1;
uniform vec4 color2;

uniform float threshold;
uniform float smoothness;
varying vec2 mainTexCoord;

void main()
{
	vec4 dst;

    dst = texture2D( tt_uniform_maintexture, mainTexCoord );

    float lum = (dst.r + dst.g + dst.b)*0.3334;
	
     if(lum <= (threshold-smoothness*0.5))
         lum = 0.0;
     else
     {
         if(lum >= (threshold+smoothness*0.5))
             lum = 1.0;
         else
         {
             lum = (lum - (threshold-smoothness*0.5))/smoothness;
         }
     }
   	
	dst = mix(color1,color2,lum);

	SHIFTCOMPS(dst)
	
	gl_FragColor = dst;
	
}
